/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.ParamAcumulaPuntoDAO;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.ParamAcumulaPunto;
import com.rjconsultores.ventaboletos.service.ParamAcumulaPuntoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("paramAcumulaPuntoService")
public class ParamAcumulaPuntoServiceImpl implements ParamAcumulaPuntoService {

    @Autowired
    private ParamAcumulaPuntoDAO paramAcumulaPuntoDAO;

    public List<ParamAcumulaPunto> obtenerTodos() {
        return paramAcumulaPuntoDAO.obtenerTodos();
    }

    public ParamAcumulaPunto obtenerID(Integer id) {
        return paramAcumulaPuntoDAO.obtenerID(id);
    }

    @Transactional
    public ParamAcumulaPunto suscribir(ParamAcumulaPunto entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return paramAcumulaPuntoDAO.suscribir(entidad);
    }

    @Transactional
    public ParamAcumulaPunto actualizacion(ParamAcumulaPunto entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return paramAcumulaPuntoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(ParamAcumulaPunto entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        paramAcumulaPuntoDAO.actualizacion(entidad);
    }

    public List<ParamAcumulaPunto> buscar(Parada origem, Parada destino, Date ini, Date fim) {
        return paramAcumulaPuntoDAO.buscar(origem, destino, ini, fim);
    }
}
